; thin blue rod by Rodrigo Silva
; based on "thin red line", part of "2600 101" tutorial by Kirk Israel

	processor 6502
	include vcs.h

	org $1000	;ok, I know $F000 is the standart, but as I still
			;couldn't figure out why the ROM origin convention is
			;the $Fxxx mirror instead of the "plain" original $1xxx
			;I will use $1000 as it seems a lot more natural to me

; I know I will be crucified, but i ripped off all the ClearMem codes, for
; several reasons. 1st, no need to clear RAM I wont use, or set flags that
; wont interfere with the program (like SEI). 2nd, both PCAE and Z26 already do
; this "housekeeping" and start themselves with everything reset. Im aware that
; this is not good programming practice, and if one would run this in a real VCS
; things wouldnt be so smooth. But this is not the case, the point here is to
; make the code as small and simple as possible, and go down to bussiness :)

Start
	LDA #$1E	; Changed the background color from the original black
	STA COLUBK	; to a bright yellow. It gives some clues about the
			; "misterious dot".

	LDA #$80	; For contrast purposes, changed line color from "red"
	STA COLUP0	; to blue. 
	
; Here is the 1st bug in the original code: the missile color was #33, which is
; 21 in hex, corresponding to a somewhat dark-orange/light-brown that had 
; nothing to do with red. Guess the intented color was #$33 (#51), which is far
; more similar to red (althought I think #$40 or #$42 is more appropriate)


	LDA #2		; enabling Missile 0
	STA ENAM0	; Btw, is it ok to enable an object even before the
			; 1st Vsync?

	LDA #$F0	; Setting Missile 0 "speed" (horiz. movement) to -1
	STA HMM0
	

MainLoop

	LDA #2		; Simple VSync blow off. Almost identical to original
	STA VBLANK	; except for the VBLANK which is set here instead of	
	STA VSYNC	; at the end of the loop. I did so so it could be set on
	STA WSYNC	; the very 1st frame. Is this OK? I also ripped off the
	STA WSYNC	; timer stuff because i rather use the simple and, as 
	STA WSYNC	; far as i know, more accurate DEX/BNE loop for waiting
	LDA #0		; Such a loop is used in the original code in the 
	STA VSYNC	; Overscan routine. As it seemed a very neat loop, i 
			; used it everywhere needed.


	LDX #37		; Set the loop counter: 37 vertical blank lines
VBlankLoop
	DEX		; DEX is the 1st statement of the loop, so loop counter
	STA WSYNC	; ranges from 36 to 0, which i think is a good	
	BNE VBlankLoop	; convention. Btw, is it?
	
	
	STX VBLANK	; Clear VBlank
	
	
	LDX #192	; Set 192 scanlines and blow them off :)
ScanLoop
	DEX
	STA WSYNC
	BNE ScanLoop
	

	LDX #30		; Set 30 Overscan lines and guess what?
OverScanWait
	DEX
	STA WSYNC	; Yes, you're right: blow them! :)
	BNE OverScanWait

	STA HMOVE	; At the end of the frame, move the Missile
	
; In my opinion, the HMOVE handling is the heart of the "misterious dot". I 
; tried to place it at the end of the frame, so in the 1st frame the line is 
; drawn at position 0. Also, every dot in the line is drawn together, and every 
; visible scanline is done before the HMOVE. This is the only way i can 
; guarantee there will be no "out-of-sync" dots. Btw, Im aware that a HMOVE must 
; be *immediatly* after a WSYNC, but... being just a single BNE apart could be 
; considered "immediatly after" ?
	
	JMP  MainLoop
	
	org $1FFC
	.word Start
	.word Start